diff --git a/arch/arm/mach-uniphier/clk/clk-ld4.c b/arch/arm/mach-uniphier/clk/clk-ld4.c
index f11fb53..8744d26 100644
--- a/arch/arm/mach-uniphier/clk/clk-ld4.c
+++ b/arch/arm/mach-uniphier/clk/clk-ld4.c
@@ -27,7 +27,7 @@ void uniphier_ld4_clk_init(void)
 	writel(tmp, SC_RSTCTRL);
 	readl(SC_RSTCTRL); /* dummy read */
 
-	/* privide clocks */
+	/* provide clocks */
 	tmp = readl(SC_CLKCTRL);
 #ifdef CONFIG_UNIPHIER_ETH
 	tmp |= SC_CLKCTRL_CEN_ETHER;
diff --git a/arch/arm/mach-uniphier/clk/clk-pro4.c b/arch/arm/mach-uniphier/clk/clk-pro4.c
index b163e3c..8746d7d 100644
--- a/arch/arm/mach-uniphier/clk/clk-pro4.c
+++ b/arch/arm/mach-uniphier/clk/clk-pro4.c
@@ -38,7 +38,7 @@ void uniphier_pro4_clk_init(void)
 	readl(SC_RSTCTRL2); /* dummy read */
 #endif
 
-	/* privide clocks */
+	/* provide clocks */
 	tmp = readl(SC_CLKCTRL);
 #ifdef CONFIG_USB_XHCI_UNIPHIER
 	tmp |= SC_CLKCTRL_CEN_USB31 | SC_CLKCTRL_CEN_USB30 |
diff --git a/arch/arm/mach-uniphier/clk/clk-pro5.c b/arch/arm/mach-uniphier/clk/clk-pro5.c
index 628f5c8..823bb06 100644
--- a/arch/arm/mach-uniphier/clk/clk-pro5.c
+++ b/arch/arm/mach-uniphier/clk/clk-pro5.c
@@ -31,7 +31,7 @@ void uniphier_pro5_clk_init(void)
 	readl(SC_RSTCTRL2); /* dummy read */
 #endif
 
-	/* privide clocks */
+	/* provide clocks */
 	tmp = readl(SC_CLKCTRL);
 #ifdef CONFIG_USB_XHCI_UNIPHIER
 	tmp |= SC_CLKCTRL_CEN_USB31 | SC_CLKCTRL_CEN_USB30 |
diff --git a/arch/arm/mach-uniphier/clk/clk-pxs2.c b/arch/arm/mach-uniphier/clk/clk-pxs2.c
index 8548353..76bf856 100644
--- a/arch/arm/mach-uniphier/clk/clk-pxs2.c
+++ b/arch/arm/mach-uniphier/clk/clk-pxs2.c
@@ -34,7 +34,7 @@ void uniphier_pxs2_clk_init(void)
 	readl(SC_RSTCTRL2); /* dummy read */
 #endif
 
-	/* privide clocks */
+	/* provide clocks */
 	tmp = readl(SC_CLKCTRL);
 #ifdef CONFIG_USB_XHCI_UNIPHIER
 	tmp |= SC_CLKCTRL_CEN_USB31 | SC_CLKCTRL_CEN_USB30 |
diff --git a/arch/arm/mach-uniphier/early-clk/early-clk-ld4.c b/arch/arm/mach-uniphier/early-clk/early-clk-ld4.c
index c98081f..b6e8b64 100644
--- a/arch/arm/mach-uniphier/early-clk/early-clk-ld4.c
+++ b/arch/arm/mach-uniphier/early-clk/early-clk-ld4.c
@@ -24,7 +24,7 @@ int uniphier_ld4_early_clk_init(const struct uniphier_board_data *bd)
 	writel(tmp, SC_RSTCTRL);
 	readl(SC_RSTCTRL); /* dummy read */
 
-	/* privide clocks */
+	/* provide clocks */
 	tmp = readl(SC_CLKCTRL);
 	tmp |= SC_CLKCTRL_CEN_UMC | SC_CLKCTRL_CEN_SBC | SC_CLKCTRL_CEN_PERI;
 	writel(tmp, SC_CLKCTRL);
diff --git a/arch/arm/mach-uniphier/early-clk/early-clk-pro5.c b/arch/arm/mach-uniphier/early-clk/early-clk-pro5.c
index 5fc8cd0..c41a8ea 100644
--- a/arch/arm/mach-uniphier/early-clk/early-clk-pro5.c
+++ b/arch/arm/mach-uniphier/early-clk/early-clk-pro5.c
@@ -26,7 +26,7 @@ int uniphier_pro5_early_clk_init(const struct uniphier_board_data *bd)
 	writel(tmp, SC_RSTCTRL4);
 	readl(SC_RSTCTRL); /* dummy read */
 
-	/* privide clocks */
+	/* provide clocks */
 	tmp = readl(SC_CLKCTRL);
 	tmp |= SC_CLKCTRL_CEN_SBC | SC_CLKCTRL_CEN_PERI;
 	writel(tmp, SC_CLKCTRL);
diff --git a/arch/arm/mach-uniphier/early-clk/early-clk-pxs2.c b/arch/arm/mach-uniphier/early-clk/early-clk-pxs2.c
index 92b2dcb..665ecd5 100644
--- a/arch/arm/mach-uniphier/early-clk/early-clk-pxs2.c
+++ b/arch/arm/mach-uniphier/early-clk/early-clk-pxs2.c
@@ -30,7 +30,7 @@ int uniphier_pxs2_early_clk_init(const struct uniphier_board_data *bd)
 	writel(tmp, SC_RSTCTRL4);
 	readl(SC_RSTCTRL4); /* dummy read */
 
-	/* privide clocks */
+	/* provide clocks */
 	tmp = readl(SC_CLKCTRL);
 	tmp |= SC_CLKCTRL_CEN_SBC | SC_CLKCTRL_CEN_PERI;
 	writel(tmp, SC_CLKCTRL);
diff --git a/lib/Kconfig b/lib/Kconfig
index 7a45336..2b97c2b 100644
--- a/lib/Kconfig
+++ b/lib/Kconfig
@@ -16,7 +16,7 @@ config USE_PRIVATE_LIBGCC
 	depends on HAVE_PRIVATE_LIBGCC
 	help
 	  This option allows you to use the built-in libgcc implementation
-	  of U-Boot instead of the one privided by the compiler.
+	  of U-Boot instead of the one provided by the compiler.
 	  If unsure, say N.
 
 config SYS_HZ